<?php

class iGlooIntegrations
{

    public function paypalIPN($settings, $user)
    {
        // $wp_upload_dir = wp_upload_dir();
        // file_put_contents($wp_upload_dir["basedir"] . '/test.txt', file_get_contents('php://input'));

        $ipn = new PayPalIPN();

        // Use the sandbox endpoint during testing.
        // $ipn->useSandbox();
        $verified = $ipn->verifyIPN();

        if ($verified) {
            // Process IPN
            // A list of variables is available here:
            // https://developer.paypal.com/webapps/developer/docs/classic/ipn/integration-guide/IPNandPDTVariables/

            // Item number
            if (isset($_POST["item_number"]))
                $item_number = $_POST["item_number"];
            else if (isset($_POST["item_number1"]))
                $item_number = $_POST["item_number1"];
            else
                die("product not found");

            // Searching for Level
            $level = null;
            if (!empty($settings["levels"]))
            foreach ($settings["levels"] as $key => $value) {
                if ($item_number == $value["uuid"])
                    $level = $value;
            }
            if (!$level)
                die("product not found");

            // Generating password
            $password = igGenerateAlpha(8);

            // Creating the User
            $res = $user->create(array(
                "email" => $_POST["payer_email"],
                "password" => $password,
                "first_name" => $_POST["first_name"],
                "last_name" => $_POST["last_name"],
                "name" => $_POST["first_name"] . " " . $_POST["last_name"],
                "level" => $level["id"],
            ), $settings);

            // If already exists we'll try to extend the expiration (it could be a renew)
            // It'll fail if the level is a non-expiry one
            if (isset($res["error"]) && $res["code"] == "EMAIL_EXISTS")
            {
                $res = $user->extendExpiration(array(
                    "email" => $_POST["payer_email"],
                    "password" => $password,
                    "first_name" => $_POST["first_name"],
                    "last_name" => $_POST["last_name"],
                    "name" => $_POST["first_name"] . " " . $_POST["last_name"],
                    "level" => $level["id"],
                ), $settings);
            }

            // Otherwise if the user has just been created we output the access details [and send him an email]
            else if (!isset($res["error"]))
            {
                // Body
                $message = $settings["purchase_email_body"];
                $message = str_replace("{{email}}", $_POST["payer_email"], $message);
                $message = str_replace("{{password}}", $password, $message);
                // $message = str_replace("{{login_url}}", $settings["site_url"] . "?iglogin=1", $message);
                $message = str_replace("{{login_url}}", $settings["site_url"] . "/" . $settings["login_page_url"], $message);

                // Send Email
                $to = $_POST["payer_email"];
                $subject = $settings["purchase_email_subject"];
                $headers = "From: " . $settings["email_sender_name"] . " <" . $settings["email_sender"] . ">\r\n";
                $headers .= "MIME-Version: 1.0\r\n";
                $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
                mail($to, $subject, nl2br($message), $headers);
            }

        }

        // Reply with an empty 200 response to indicate to paypal the IPN was received correctly.
        header("HTTP/1.1 200 OK");
        exit;
    }


    public function jvzooIPN($settings, $user)
    {
        // Security Code
        if ($_GET["v"] != $settings["sec_code"])
            die("security check failed");

        if (!isset($_POST["ccustemail"]) || !isset($_POST["ccustname"]))
            die();

        // Searching for Level
        $level = null;
        if (!empty($settings["levels"]))
        foreach ($settings["levels"] as $key => $value) {
            if ($_GET["uuid"] == $value["uuid"])
                $level = $value;
        }
        if (!$level)
            die("product not found");

        // Generating password
        $password = igGenerateAlpha(8);

        // Creating the User
        $res = $user->create(array(
            "email" => $_POST["ccustemail"],
            "password" => $password,
            "name" => $_POST["ccustname"],
            "level" => $level["id"],
        ), $settings);

        // If already exists we'll try to extend the expiration (it could be a renew)
        // It'll fail if the level is a non-expiry one
        if (isset($res["error"]) && $res["code"] == "EMAIL_EXISTS")
        {
            $res = $user->extendExpiration(array(
                "email" => $_POST["ccustemail"],
                "password" => $password,
                "name" => $_POST["ccustname"],
                "level" => $level["id"],
            ), $settings);

            // Body
            $output = "Your account expiration has been updated.<br />Thank you!";
            echo $output;
        }

        // Otherwise if the user has just been created we output the access details [and send him an email]
        else if (!isset($res["error"]))
        {
            // Body
            $message = $settings["purchase_email_body"];
            $message = str_replace("{{email}}", $_POST["ccustemail"], $message);
            $message = str_replace("{{password}}", $password, $message);
            // $message = str_replace("{{login_url}}", $settings["site_url"] . "?iglogin=1", $message);
            $message = str_replace("{{login_url}}", $settings["site_url"] . "/" . $settings["login_page_url"], $message);

            // Send Email
            $to = $_POST["ccustemail"];
            $subject = $settings["purchase_email_subject"];
            $headers = "From: " . $settings["email_sender_name"] . " <" . $settings["email_sender"] . ">\r\n";
            $headers .= "MIME-Version: 1.0\r\n";
            $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
            mail($to, $subject, nl2br($message), $headers);

            // Text shown on the JVZoo purchase page
            echo nl2br($message);
        }

        die();
    }


    public function samcartIPN($settings, $user)
    {
        // Security Code
        if ($_GET["v"] != $settings["sec_code"])
            die("security check failed");

        $event_json = @file_get_contents("php://input");
        $decode = json_decode($event_json, true);

        $customer_fname = $decode['customer']['first_name'];
        $customer_lname = $decode['customer']['last_name'];
        $customer_email = $decode['customer']['email'];
        $uuid = $_GET['uuid'];

        // iglooAddAutoresponder($customer_email, $customer_fname, $customer_lname); // Adding the email to autoresponder lists

        $level = null;
        if (!empty($settings["levels"]))
        foreach ($settings["levels"] as $key => $value) {
            if ($uuid == $value["uuid"])
                $level = $value;
        }

        $password = igGenerateAlpha(8);

        // Creating the User
        $res = $user->create(array(
            "email" => $customer_email,
            "password" => $password,
            "name" => $customer_fname . ' ' . $customer_lname,
            "level" => $level["id"],
        ), $settings);

        // If already exists we'll try to extend the expiration (it could be a renew)
        // It'll fail if the level is a non-expiry one
        if (isset($res["error"]) && $res["code"] == "EMAIL_EXISTS")
        {
            $res = $user->extendExpiration(array(
                "email" => $customer_email,
                "password" => $password,
                "name" => $customer_fname . ' ' . $customer_lname,
                "level" => $level["id"],
            ), $settings);

            // Body
            $output = "Your account expiration has been updated.<br />Thank you!";
            echo $output;
        }

        // Otherwise if the user has just been created we output the access details [and send him an email]
        else if (!isset($res["error"]))
        {
            // Body
            $message = $settings["purchase_email_body"];
            $message = str_replace("{{email}}", $customer_email, $message);
            $message = str_replace("{{password}}", $password, $message);
            // $message = str_replace("{{login_url}}", $settings["site_url"] . "?iglogin=1", $message);
            $message = str_replace("{{login_url}}", $settings["site_url"] . "/" . $settings["login_page_url"], $message);

            // Send Email
            $to = $customer_email;
            $subject = $settings["purchase_email_subject"];
            $headers = "From: " . $settings["email_sender_name"] . " <" . $settings["email_sender"] . ">\r\n";
            $headers .= "MIME-Version: 1.0\r\n";
            $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
            wp_mail($to, $subject, nl2br($message), $headers);

            // Text shown on the JVZoo purchase page
            echo nl2br($message);
        }

        exit;
    }


    public function paykickstartIPN($settings, $user)
    {
        // Security Code
        if ($_GET["v"] != $settings["sec_code"])
            die("security check failed");

        $event_json = @file_get_contents("php://input");
        $decode = json_decode($event_json, true);

        if (!isset($_POST['buyer_first_name']) || !isset($_POST['buyer_last_name']) || !isset($_POST['buyer_email']))
            die();

        $customer_fname = $_POST['buyer_first_name'];
        $customer_lname = $_POST['buyer_last_name'];
        $customer_email = $_POST['buyer_email'];
        $uuid = $_GET['uuid'];

        // iglooAddAutoresponder($customer_email, $customer_fname, $customer_lname); // Adding the email to autoresponder lists


        $level = null;
        if (!empty($settings["levels"]))
        foreach ($settings["levels"] as $key => $value) {
            if ($uuid == $value["uuid"])
                $level = $value;
        }

        $password = igGenerateAlpha(8);

        // Creating the User
        $res = $user->create(array(
            "email" => $customer_email,
            "password" => $password,
            "name" => $customer_fname . ' ' . $customer_lname,
            "level" => $level["id"],
        ), $settings);

        // If already exists we'll try to extend the expiration (it could be a renew)
        // It'll fail if the level is a non-expiry one
        if (isset($res["error"]) && $res["code"] == "EMAIL_EXISTS")
        {
            $res = $user->extendExpiration(array(
                "email" => $customer_email,
                "password" => $password,
                "name" => $customer_fname . ' ' . $customer_lname,
                "level" => $level["id"],
            ), $settings);

            // Body
            $output = "Your account expiration has been updated.<br />Thank you!";
            echo $output;
        }

        // Otherwise if the user has just been created we output the access details [and send him an email]
        else if (!isset($res["error"]))
        {
            // Body
            $message = $settings["purchase_email_body"];
            $message = str_replace("{{email}}", $customer_email, $message);
            $message = str_replace("{{password}}", $password, $message);
            // $message = str_replace("{{login_url}}", $settings["site_url"] . "?iglogin=1", $message);
            $message = str_replace("{{login_url}}", $settings["site_url"] . "/" . $settings["login_page_url"], $message);

            // Send Email
            $to = $customer_email;
            $subject = $settings["purchase_email_subject"];
            $headers = "From: " . $settings["email_sender_name"] . " <" . $settings["email_sender"] . ">\r\n";
            $headers .= "MIME-Version: 1.0\r\n";
            $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
            wp_mail($to, $subject, nl2br($message), $headers);

            // Text shown on the JVZoo purchase page
            echo nl2br($message);
        }

        exit;
    }


    public function digistoreIPN($settings, $user)
    {
        // Security Code
        if ($_GET["v"] != $settings["sec_code"])
            die("security check failed");

        //$uuid = $input['product_id'];
        $customer_email = $_POST['email'];
        $customer_fname = $_POST['first_name'];
        $customer_lname = $_POST['last_name'];

        // iglooAddAutoresponder($customer_email, $customer_fname, $customer_lname); // Adding the email to autoresponder lists

        $level = null;
        if (!empty($settings["levels"]))
        foreach ($settings["levels"] as $key => $value) {
            if ($uuid == $value["uuid"])
                $level = $value;
        }

        $password = igGenerateAlpha(8);

        // Creating the User
        $res = $user->create(array(
            "email" => $customer_email,
            "password" => $password,
            "name" => $customer_fname . ' ' . $customer_lname,
            "level" => $level["id"],
        ), $settings);

        // If already exists we'll try to extend the expiration (it could be a renew)
        // It'll fail if the level is a non-expiry one
        if (isset($res["error"]) && $res["code"] == "EMAIL_EXISTS")
        {
            $res = $user->extendExpiration(array(
                "email" => $customer_email,
                "password" => $password,
                "name" => $customer_fname . ' ' . $customer_lname,
                "level" => $level["id"],
            ), $settings);

            // Body
            $output = "Your account expiration has been updated.<br />Thank you!";
            echo $output;
        }

        // Otherwise if the user has just been created we output the access details [and send him an email]
        else if (!isset($res["error"]))
        {
            // Body
            $message = $settings["purchase_email_body"];
            $message = str_replace("{{email}}", $customer_email, $message);
            $message = str_replace("{{password}}", $password, $message);
            // $message = str_replace("{{login_url}}", $settings["site_url"] . "?iglogin=1", $message);
            $message = str_replace("{{login_url}}", $settings["site_url"] . "/" . $settings["login_page_url"], $message);

            // Send Email
            $to = $customer_email;
            $subject = $settings["purchase_email_subject"];
            $headers = "From: " . $settings["email_sender_name"] . " <" . $settings["email_sender"] . ">\r\n";
            $headers .= "MIME-Version: 1.0\r\n";
            $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
            wp_mail($to, $subject, nl2br($message), $headers);

            // Text shown on the JVZoo purchase page
            echo nl2br($message);
        }

        exit;

    }

    public function stripeIPN($settings, $user)
    {
        // $wp_upload_dir = wp_upload_dir();
        // file_put_contents($wp_upload_dir["basedir"] . '/test.txt', file_get_contents('php://input'));

        // Security Code
        if ($_GET["v"] != $settings["sec_code"])
            die("security check failed");

        $input = @file_get_contents("php://input");
        if ($input == "")
            die();

        $decode = json_decode($input, true);

        $uuid = $decode['data']['object']['description'];
        $customer_email = $decode['data']['object']['source']['name'];

        $customer_fname = '-';
        $customer_lname = '-';
        // iglooAddAutoresponder($customer_email, $customer_fname, $customer_lname); // Adding the email to autoresponder lists

        $level = null;
        if (!empty($settings["levels"]))
        foreach ($settings["levels"] as $key => $value) {
            if ($uuid == $value["uuid"])
                $level = $value;
        }

        $password = igGenerateAlpha(8);

        // Creating the User
        $res = $user->create(array(
            "email" => $customer_email,
            "password" => $password,
            "name" => $customer_fname . ' ' . $customer_lname,
            "level" => $level["id"],
        ), $settings);

        // If already exists we'll try to extend the expiration (it could be a renew)
        // It'll fail if the level is a non-expiry one
        if (isset($res["error"]) && $res["code"] == "EMAIL_EXISTS")
        {
            $res = $user->extendExpiration(array(
                "email" => $customer_email,
                "password" => $password,
                "name" => $customer_fname . ' ' . $customer_lname,
                "level" => $level["id"],
            ), $settings);

            // Body
            $output = "Your account expiration has been updated.<br />Thank you!";
            echo $output;
        }

        // Otherwise if the user has just been created we output the access details [and send him an email]
        else if (!isset($res["error"]))
        {
            // Body
            $message = $settings["purchase_email_body"];
            $message = str_replace("{{email}}", $customer_email, $message);
            $message = str_replace("{{password}}", $password, $message);
            // $message = str_replace("{{login_url}}", $settings["site_url"] . "?iglogin=1", $message);
            $message = str_replace("{{login_url}}", $settings["site_url"] . "/" . $settings["login_page_url"], $message);

            // Send Email
            $to = $customer_email;
            $subject = $settings["purchase_email_subject"];
            $headers = "From: " . $settings["email_sender_name"] . " <" . $settings["email_sender"] . ">\r\n";
            $headers .= "MIME-Version: 1.0\r\n";
            $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
            wp_mail($to, $subject, nl2br($message), $headers);

            // Text shown on the JVZoo purchase page
            echo nl2br($message);
        }

        exit;
    }
}

?>
