<?php
/*!
Plugin Name: iGloo Membership
Plugin URI: https://launchigloo.com
Description: iGloo Membership - Protect your iGloo pages
Author: iglooapp.com
Version: 1.1.6
Author URI: https://launchigloo.com
*/


if (!class_exists('WP')) {
   header('Status: 403 Forbidden');
   header('HTTP/1.1 403 Forbidden');
   exit;
}

include "include/helpers.php";
include "include/paypal_ipn/PaypalIPN.php";
include "classes/user.class.php";
include "classes/integrations.class.php";


define("IGLOO_MEMBERSHIP_AJAX_SECURITY", "sd6f9g2389gd76fg9e89dsf");


class iGlooMembership
{
    const PLUGIN_NAME = 'igloo_membership';
    const PLUGIN_LABEL = 'iGloo Member';
    const VERSION = '1.1.5';


    public $defaults_settings = array(
        "login_page_url" => "user-login",
        "login_settings" => array(
            "template" => "login1",
            "login1" => array(
                "bg_color" => "#ffffff",
                "bg_use_image" => "true",
                // "bg_image" => undefined,
                "box_bg_color" => "#1b3455",
                "box_shadow_color" => "#0e1e39",
                // "logo_image" => undefined,
                "button_text" => "Login to iGloo Member",
                "button_text_color" => "#ffffff",
                "button_bg_color" => "#39bed7",
                "button_shadow_color" => "#26a8c0",
                "forgot_password_text" => "Ah.. yeah, forgot my password..",
            ),
            "login2" => array(
                "title" => "Login to iGloo member",
                "title_color" => "#ffce21",
                "bg_color" => "#ffffff",
                "bg_use_image" => "true",
                // "bg_image" => undefined,
                "box_bg_color" => "#0ca0e1",
                // "logo_image" => undefined,
                "button_text" => "Login to iGloo Member",
                "button_text_color" => "#ffffff",
                "button_bg_color" => "#afc155",
                "forgot_password_text" => "Ah.. yeah, forgot my password..",
            ),
            "login3" => array(
                "bg_color" => "#ffffff",
                "bg_use_image" => "true",
                // "bg_image" => undefined,
                // "logo_image" => undefined,
                "button_text" => "Login to iGloo Member",
                "button_text_color" => "#ffffff",
                "button_bg_color" => "#ff4040",
                "forgot_password_text" => "Ah.. yeah, forgot my password..",
            )
        ),
        "signup_settings" => array(
            "template" => "signup1",
            "signup1" => array(
                "bg_color" => "#ffffff",
                "bg_use_image" => "true",
                // "bg_image" => undefined,
                "box_bg_color" => "#1b3455",
                "box_shadow_color" => "#0e1e39",
                // "logo_image" => undefined,
                "button_text" => "Signup to iGloo Member",
                "button_text_color" => "#ffffff",
                "button_bg_color" => "#39bed7",
                "button_shadow_color" => "#26a8c0",
            ),
            "signup2" => array(
                "title" => "Signup to iGloo member",
                "title_color" => "#ffce21",
                "bg_color" => "#ffffff",
                "bg_use_image" => "true",
                // "bg_image" => undefined,
                "box_bg_color" => "#0ca0e1",
                // "logo_image" => undefined,
                "button_text" => "Signup to iGloo Member",
                "button_text_color" => "#ffffff",
                "button_bg_color" => "#afc155",
            ),
            "signup3" => array(
                "bg_color" => "#ffffff",
                "bg_use_image" => "true",
                // "bg_image" => undefined,
                // "logo_image" => undefined,
                "button_text" => "Signup to iGloo Member",
                "button_text_color" => "#ffffff",
                "button_bg_color" => "#ff4040",
            )
        ),
        "logout_settings" => array(
            "position" => "bottom_left",
            "text" => "Logout",
            "bg_color" => "#000000",
            "color" => "#ffffff"
        ),
        "email_sender" => "",
        "email_sender_name" => "",
        "signup_email_subject" => "Access Details",
        "signup_email_body" => "Thank you!

These are your login details:
Email: {{email}}
Password: {{password}}

You can login here: {{login_url}}
Regards",
        "purchase_email_subject" => "Access Details",
        "purchase_email_body" => "Thank you!

These are your login details:
Email: {{email}}
Password: {{password}}

You can login here: {{login_url}}
Regards",
        "password_reset_email_subject" => "Password Reset",
        "password_reset_email_body" => "This email was sent to you because someone requested a password reset on your account.

Visit the following URL to choose a new password:

{{url}}

You can login at: {{login_url}}",

    );



    public function __construct()
    {
        global $wpdb;
        global $plugin;

        $this->ROOT_FILE = __FILE__;
        $this->ROOT_PATH = dirname(__FILE__);
        $this->ROOT_URL = plugins_url('', __FILE__);
        $this->PLUGIN_SLUG = basename(dirname(__FILE__));
        $this->PLUGIN_BASE = plugin_basename(__FILE__);
        $this->PLUGIN_URL = WP_PLUGIN_URL . '/' . basename(dirname(__FILE__));
        $this->ADMIN_BASE_URL = site_url() . "/wp-admin/admin.php";

        // echo $this->ROOT_FILE . "<br />";
        // echo $this->ROOT_PATH . "<br />";
        // echo $this->ROOT_URL . "<br />";
        // echo $this->PLUGIN_SLUG . "<br />";
        // echo $this->PLUGIN_BASE . "<br />";
        // echo $this->PLUGIN_URL . "<br />";
        // echo $this->ADMIN_BASE_URL . "<br />";

        $this->igloo_token = false;

        // Detecting SSL
        // if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off')
        // {
        //     $this->PLUGIN_URL = str_replace("http://", "https://", $this->PLUGIN_URL);
        //     $this->ADMIN_BASE_URL = str_replace("http://", "https://", $this->ADMIN_BASE_URL);
        // }

        register_activation_hook(__FILE__, array($this, 'activate'));
        register_deactivation_hook(__FILE__, array($this, 'deactivate'));

        $tablePrefix = $wpdb->base_prefix;
        if (is_multisite()) {
            global $blog_id;
            // echo "BLOG_ID: *" . $blog_id . "*<br>";
            if ($blog_id != 1)
                $tablePrefix .= $blog_id . "_";
        }

        $this->DB_USER_TABLE = $tablePrefix . 'igloo_users';

        $this->user = new iGlooUser();
        $this->user->DB_USER_TABLE = $this->DB_USER_TABLE;

        $this->integrations = new iGlooIntegrations();

        add_action('init', array($this, 'onWPInit'));
    }






    public function activate()
    {
        global $wpdb;

        if (is_multisite() && isset($_GET['networkwide']) && ($_GET['networkwide'] == 1))
        {
            $originalBlogId = get_current_blog_id();
            $blogs = $wpdb->get_results("SELECT blog_id FROM {$wpdb->blogs} WHERE site_id = '{$wpdb->siteid}' AND spam = '0' AND deleted = '0' AND archived = '0'");
            foreach ($blogs as $blog_id)
            {
                switch_to_blog($blog_id->blog_id);
                $this->doActivate();
            }
            switch_to_blog($originalBlogId);
        }

        else
        {
            $this->doActivate();
        }

    }




    public function doActivate()
    {
        global $wpdb;

// delete_option(self::PLUGIN_NAME . "_version");
// delete_option(self::PLUGIN_NAME . '_settings');

        update_option(self::PLUGIN_NAME . "_version", self::VERSION);

        // First Time
        $settings = get_option(self::PLUGIN_NAME . '_settings');
        if (!$settings) {
            $settings = array("sec_code" => igGenerateAlpha(10));
            update_option(self::PLUGIN_NAME . '_settings', $settings);
        }

        // Login Url
        if (!isset($settings["login_page_url"]))
            $settings["login_page_url"] = "user-login";
        // $res = $this->updateLoginPage($settings);
        // $settings["login_page_id"] = $res["id"];


        // if (isset($settings["login_page_id"]))
        //     wp_delete_post($settings["login_page_id"], true);

// var_dump($settings["login_page_id"]);
// var_dump(get_post_status($settings["login_page_id"]));

        // La pagina non esiste, la creo
        if (is_null($settings["login_page_id"]) || isset($settings["login_page_id"]) && false === get_post_status($settings["login_page_id"]))
        {
            // Page Content
            $page_content = "This page has been created by iGloo Member plugin. Please do not edit or delete this page.";

            // Create Page
            $login_page = array(
                // 'ID' => (!isset($settings["login_page_id"]) || $settings["login_page_id"] == 0) ? 0 : $settings["login_page_id"],
                'post_name' => wp_strip_all_tags($settings["login_page_url"]),
                'post_title' => wp_strip_all_tags($settings["login_page_url"]),
                'post_content' => $page_content,
                'post_status' => 'publish',
                // 'post_author' => 1,
                'post_type' => "page",
                'comment_status' => 'closed',
                'ping_status' => 'closed'
            );
            $login_page_id = wp_insert_post($login_page);
            $settings["login_page_id"] = $login_page_id;
        }

        // La pagina esiste
        else
        {

        }

        // if (!isset($settings["login_page_id"]) || $settings["login_page_id"] == 0)
            // $settings["login_page_id"] = $login_page_id;

        update_option(self::PLUGIN_NAME . '_settings', $settings);

        // Re-activation
        // else
        // {
        //     // echo "1";
        //     $settings = $this->getSettings();
        //     // preize($settings);
        //     if (!isset($settings["sec_code"])) {
        //         $settings["sec_code"] = igGenerateAlpha(10);
        //         // preize($settings);
        //         // die;
        //         update_option(self::PLUGIN_NAME . '_settings', $settings);
        //     }
        // }

        $tablePrefix = $wpdb->base_prefix;
        if (is_multisite()) {
            global $blog_id;
            if ($blog_id != 1)
                $tablePrefix .= $blog_id . "_";
        }

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        $charset_collate = $wpdb->get_charset_collate();

        // Users Table
        if($wpdb->get_var("SHOW TABLES LIKE '" . $this->DB_USER_TABLE . "'") != $tablePrefix . 'igloo_users')
        {
            $sql = "
CREATE TABLE `" . $tablePrefix . 'igloo_users' . "` (
    `id` BIGINT(20) NOT NULL AUTO_INCREMENT,
    `level` BIGINT(20) NOT NULL,
    `first_name` varchar(255) DEFAULT NULL,
    `last_name` varchar(255) DEFAULT NULL,
    `name` varchar(255) DEFAULT NULL,
    `email` varchar(255) DEFAULT NULL,
    `password` varchar(255) DEFAULT NULL,
    `expire_at` date,
    `created_at` datetime,
    `settings` LONGTEXT NOT NULL,
    `token` varchar(255) DEFAULT NULL,
    `reset_code` varchar(255) DEFAULT NULL,
    PRIMARY KEY (`id`)
) $charset_collate;";
            dbDelta($sql);
        }
    }



    public function deactivate()
    {
    }



    public function checkLoginUrl()
    {
        global $wp_query;

        if (!isset($wp_query->query_vars["name"]))
            return true;

        $settings = $this->getSettings();
        if ($wp_query->query_vars["name"] == $settings["login_page_url"])
            $this->showLogin();
    }


    public function onWPInit()
    {
        // add_action('pre_get_posts', array($this, 'checkLoginUrl'), 0);
        add_action('wp', array($this, 'checkLoginUrl'), 0);

        if (is_admin())
        {
            add_action('admin_menu', array($this, 'addToMenu'));

            if (isset($_GET['page']) && $_GET['page'] == self::PLUGIN_NAME . '_admin')
                add_action('admin_enqueue_scripts', array($this, 'adminEnqueue'), 99999);

            add_action('wp_ajax_im_ajax_router', array($this, 'ajaxRouter'));
        }

        else
        {
            // Integrations with Payment Platforms
            if (isset($_GET["igm_jvzoo"]))
                $this->integrations->jvzooIPN($this->getSettings(), $this->user);

            if (isset($_GET["igm_paypal"]))
                $this->integrations->paypalIPN($this->getSettings(), $this->user);

            if (isset($_GET["igm_samcart"]))
                $this->integrations->samcartIPN($this->getSettings(), $this->user);

            if (isset($_GET["igm_stripe"]))
                $this->integrations->stripeIPN($this->getSettings(), $this->user);

            if (isset($_GET["igm_paykickstart"]))
                $this->integrations->paykickstartIPN($this->getSettings(), $this->user);

            if (isset($_GET["igm_digistore"]))
                $this->integrations->digistoreIPN($this->getSettings(), $this->user);




            if (isset($_GET["iglpreview"]))
                $this->showLogin($_GET["igtpl"]);

            if (isset($_GET["igspreview"]))
                $this->showRegistration(false, $_GET["igtpl"]);

            if (isset($_GET["igreg"]))
                $this->checkRegistration($_GET["igreg"]);

            if (isset($_GET["iglogin"]))
                $this->showLogin();

            // if (!$this->isAdmin())
                add_action('wp', array($this, 'checkPage'));
        }
    }







    public function addToMenu()
    {
        add_menu_page(
            self::PLUGIN_LABEL,
            self::PLUGIN_LABEL,
            "manage_options",
            self::PLUGIN_NAME . '_admin',
            array($this, 'loadAdminPages'),
            plugin_dir_url( __FILE__ ) . "/admin/images/menu-icon.png"
        );
    }


    public function loadAdminPages()
    {
        global $wpdb;
        $current_page = isset($_GET['ac']) ? $_GET['ac'] : '';
        switch($current_page)
        {
            default:
                include('admin/views/admin.php');
                break;
        }
    }



    public function adminEnqueue()
    {
        wp_enqueue_media();
        wp_enqueue_style('thickbox');
        wp_enqueue_script('thickbox');
        wp_enqueue_script('jquery');

        echo '<script>var igloo_membership_plugin_url = "' . $this->PLUGIN_URL . '";</script>';

        wp_enqueue_style(self::PLUGIN_NAME . '-admin-css-jqueryui-smoothness', '//ajax.googleapis.com/ajax/libs/jqueryui/1.11.2/themes/smoothness/jquery-ui.css');
        wp_enqueue_style(self::PLUGIN_NAME . '-admin-css', $this->PLUGIN_URL . '/admin/css/admin.min.css');
        wp_enqueue_style(self::PLUGIN_NAME . '-admin-css-awesome', $this->PLUGIN_URL . '/vendor/font-awesome/css/font-awesome.min.css');


        wp_enqueue_script(self::PLUGIN_NAME . '-admin-js-vendor', $this->PLUGIN_URL . '/admin/js/vendors.min.js');

        wp_enqueue_script(self::PLUGIN_NAME . '-admin-js-app', $this->PLUGIN_URL . '/admin/js/app.min.js');

        wp_enqueue_script(self::PLUGIN_NAME . '-admin-js-ctrl-admin', $this->PLUGIN_URL . '/admin/controllers/admin.js');
        wp_localize_script(self::PLUGIN_NAME . '-admin-js-ctrl-admin', 'igloo_membership_ajax_router', array('wpnonce' => wp_create_nonce(IGLOO_MEMBERSHIP_AJAX_SECURITY)));
    }




    public function ajaxRouter()
    {
        if (!isset($_POST['igloo_membership_act']) || !isset($_POST['wpnonce']) || !wp_verify_nonce($_POST['wpnonce'], IGLOO_MEMBERSHIP_AJAX_SECURITY))
            die(json_encode(array('error' => __('ajax - permission denied'))));

        switch($_POST['do'])
        {
            case "iglooOTO3Passed":
                $this->ajaxOTO3Passed();
                break;

            case "iglooUpdateSettings":
                $this->ajaxUpdateSettings();
                break;

            case "iglooLoadSettings":
                $this->ajaxLoadSettings();
                break;

            case "iglooCreateLevel":
                $this->ajaxCreateLevel();
                break;

            case "iglooUpdateLevel":
                $this->ajaxUpdateLevel();
                break;

            case "iglooGetPages":
                $this->ajaxGetPages();
                break;

            case "iglooSavePages":
                $this->ajaxSavePages();
                break;

            case "iglooCreateUser":
                $this->ajaxCreateUser();
                break;

            case "iglooUpdateUser":
                $this->ajaxUpdateUser();
                break;

            case "iglooGetUsers":
                $this->ajaxGetUsers();
                break;

            case "iglooDeleteUser":
                $this->ajaxDeleteUser();
                break;
        }
    }



    // Runtime /////////////////////////////////////////////////////////////////////////////////////////////////////////


    public function isAdmin()
    {
        global $current_user;

        if (in_array("author", $current_user->roles) ||
            in_array("editor", $current_user->roles) ||
            in_array("administrator", $current_user->roles))
            return true;

        return false;
    }


    public function checkRegistration($igreg)
    {
        if (!isset($igreg))
            return;

        $settings = $this->getSettings();

        // Searching for the passed Level
        $level = null;
        if (!empty($settings["levels"]))
        foreach ($settings["levels"] as $key => $value) {
            if ($value["uuid"] == $_GET["igreg"])
                $level = $value;
        }

        // Level Found
        if (!is_null($level))
        {
            // Check Registration Fields
            if (isset($_POST["igloo_signup"]) && $_POST["igloo_signup"] == 1)
            {
                $params = $_POST;
                $params["level"] = $level["id"];
                $result = $this->user->signup($settings, $params);

                if (isset($result["error"]))
                {
                    $this->showRegistration($result);
                }

                // Success
                else
                {
                    // Autologin
                    $u = $this->user->login(array(
                        "email" => $params["email"],
                        "password" => $params["password"]
                    ), $this->getSettings());

                    // Redirect
                    if (isset($level["after_registration_page"]) && $level["after_registration_page"] != "" && $level["after_registration_page"] != "0")
                    {
                        wp_redirect(get_permalink($level["after_registration_page"]));
                        exit;
                    }
                    else
                    {
                        wp_redirect(home_url());
                        exit;
                    }
                }
            }

            // Registration - First Time
            else
                $this->showRegistration();
        }
    }



    public function checkPage()
    {
        global $post;

        if ($post === null)
            return;
        // echo "Check Page<br />";
        $levels = get_post_meta($post->ID, "igloo_levels", true);

        // Non-Protected page
        if (is_null($levels) || $levels == "")
            return true;

        $this->levels = json_decode($levels, true);

        // Non-Protected page
        if (empty($this->levels))
            return true;

        // Logout
        if (isset($_POST["igloo_logout"]) && $_POST["igloo_logout"] == 1) {
            // echo "LOGOUT<br />";
            $this->user->logout();
            // $this->showLogin();
            $this->redirectOrLogin($post->ID);
        }

        // Getting Token
        if (isset($_COOKIE["igloo_token"]))
            $this->igloo_token = $_COOKIE["igloo_token"];

        // Token found
        if ($this->igloo_token)
        {
            // echo "Token found<br />";
            // Checking Token
            $this->logged_user = $this->user->checkToken(array(
                "token" => $this->igloo_token
            ));
            // preize($this->logged_user);

            // Token not valid
            if (!$this->logged_user)
            {
                $this->user->logout();
                $this->redirectOrLogin($post->ID);
            }

            // Level not valid
            if (!isset($this->levels[$this->logged_user["level"]]))
                $this->redirectOrLogin($post->ID);
        }

        // Token not found
        else
        {
            // echo "Token not found<br />";
            // Trying to login > checking posted data
            // if (isset($_POST["igloo_login"]) && $_POST["igloo_login"] == 1) {
            //     $result = $this->login();
            // }
            //
            // // First attempt to access the protected page
            // else
                $this->redirectOrLogin($post->ID);
        }

        // Checking the Drip Feeding
        $days = get_post_meta($post->ID, "igloo_days", true);
        if (!is_null($days) && $days != "" && $days != "0")
        {
            $date1 = new DateTime(date("Y-m-d 23:59:59"));
            $date2 = new DateTime($this->logged_user["created_at"]);
            $days_since_signup = intval($date2->diff($date1)->format("%a"));
            if ($days_since_signup < $days)
                $this->redirectOrLogin($post->ID);
        }

        $this->showPage();
    }



    public function redirectOrLogin($id)
    {
        // If specified, redirect to the specified page..
        $redirect_if_not_logged = get_post_meta($id, "igloo_redirect_if_not_logged", true);

        if ($redirect_if_not_logged != "" && $redirect_if_not_logged != "0")
        {
            wp_redirect(get_permalink($redirect_if_not_logged));
            exit;
        }

        // ..otherwise Login - first time
        $this->redirectToLogin();
        // $this->showLogin();
    }



    public function showPage()
    {
        global $post;
        if ($post === null)
            return;

        $pos = strpos($post->post_content, '{{IGLOO=');

        // iGloo Page
        if ($pos !== false)
        {
            $wp_upload_dir = wp_upload_dir();
            $upload_dir = $wp_upload_dir["basedir"] . "/igloo/" . $post->ID . "/";

            $page_content = file_get_contents($upload_dir . "index.html");
            $pos = strpos($page_content, "</body>");
            if ($pos !== -1)
            {
                $bar_content = file_get_contents($this->ROOT_PATH . '/js/bar.js');
                $bar_style = $this->getBarStyle();

                $page_content =
                    substr($page_content, 0, $pos) .
                    "<script id=\"igloo_bar_js\">" .
                    $bar_style .
                    $bar_content .
                    "</script>" .
                    substr($page_content, $pos);
            }
            echo $page_content;
            exit;
        }

        // non-iGloo page
        else {
            add_action('wp_enqueue_scripts', array($this, 'barEnqueue'));
        }
    }


    public function getBarStyle()
    {
        $settings = $this->getSettings();

        $bar_style = "";

        $bar_style .= "var igloo_bar_settings = ";
        $bar_style .= json_encode(array(
            "text" => $settings["logout_settings"]["text"],
        ));
        $bar_style .= ";";

        $bar_style .= "var igloo_bar_style = ";
        $bar_style .= json_encode(array(
            "background" => $settings["logout_settings"]["bg_color"],
            "color" => $settings["logout_settings"]["color"],
            "top" => ($settings["logout_settings"]["position"] == "top_left" || $settings["logout_settings"]["position"] == "top_right") ? "10px" : "",
            "bottom" => ($settings["logout_settings"]["position"] == "bottom_left" || $settings["logout_settings"]["position"] == "bottom_right") ? "10px" : "",
            "left" => ($settings["logout_settings"]["position"] == "top_left" || $settings["logout_settings"]["position"] == "bottom_left") ? "10px" : "",
            "right" => ($settings["logout_settings"]["position"] == "top_right" || $settings["logout_settings"]["position"] == "bottom_right") ? "10px" : "",
        ));

        $bar_style .= ";";
        return $bar_style;
    }


    public function barEnqueue()
    {
        echo '<script>' . $this->getBarStyle() . '</script>';
        wp_enqueue_script('jquery');
        wp_enqueue_script(self::PLUGIN_NAME . '-js-bar', $this->PLUGIN_URL . '/js/bar.js');
    }


    public function redirectToLogin()
    {
        $settings = $this->getSettings();
        wp_redirect(get_site_url() . "/" . $settings["login_page_url"]);
        // wp_redirect(site_url() . "?iglogin=1");
        exit;
    }


    public function showLogin($template = false)
    {
        $errors = false;
        $email_sent = false;
        $password_reset = false;
        $view = "login";

        $settings = $this->getSettings();

        if ($template)
            $settings["login_settings"]["template"] = $template;

        // Reset Password
        if (isset($_POST["igloo_reset_password"]) && $_POST["igloo_reset_password"] == 1)
        {
            // Required
            if (!isset($_POST["password"]) || !isset($_POST["password2"])) {
                $errors = "Please enter a valid password";
            }

            // Password Length
            else if (strlen($_POST["password"]) < 6) {
                $errors = "Please enter a password at least 6 characters in length";
            }

            // Passwords Match
            else if ($_POST["password"] != $_POST["password2"]) {
                $errors = "The two passwords do not match";
            }

            if (!$errors)
            {
                $item = $this->user->resetPassword(array(
                    "email" => $_GET["email"],
                    "code" => $_GET["code"],
                    "password" => $_POST["password"],
                ), $this->getSettings());

                if ($item)
                    $password_reset = true;
                else
                    $errors = "Email not found";
            }
        }

        // Lost Password
        if (isset($_POST["igloo_lost_password"]) && $_POST["igloo_lost_password"] == 1)
        {
            $view = "lost_password";
            $item = $this->user->lostPassword($_POST, $this->getSettings());

            // User not found or Expired
            if (!$item) {
                $errors = "Invalid email address";
                // echo "error account<br />";
                // $this->showLogin();
            }
            else
                $email_sent = true;
        }

        else if (isset($_POST["igloo_login"]) && $_POST["igloo_login"] == 1)
        {
            $item = $this->user->login($_POST, $this->getSettings());
            // preize($item);

            // User not found or Expired
            if (!is_array($item)) {
                $errors = $item;
                // echo "error account<br />";
                // $this->showLogin();
            }

            // preize($this->levels);
            // else if (!isset($this->levels[$item["level"]])) {
            //     echo "error level<br />";
            //     // $this->showLogin();
            // }
            // if ($item["level"])

            // Logged in
            else {
                // $this->token = $item["token"];

                // Searching for the user Level
                $level = false;
                if (!empty($settings["levels"]))
                foreach ($settings["levels"] as $key => $value) {
                    if ($value["id"] == $item["level"])
                        $level = $value;
                }
                // preize($level);

                if ($level && isset($level["after_login_page"]) && $level["after_login_page"] != "" && $level["after_login_page"] != "0")
                {
                    wp_redirect(get_permalink($level["after_login_page"]));
                    exit;
                }
                else
                {
                    wp_redirect(home_url());
                    exit;
                }
            }

        }


        // Page Path & Content
        $login_template_path = $this->ROOT_PATH . "/templates/login/" . $settings["login_settings"]["template"] . "/";
        $login_template_url = $this->PLUGIN_URL . "/templates/login/" . $settings["login_settings"]["template"] . "/";
        $page_content = file_get_contents($login_template_path . "index.html");

        // Basic Replacements
        $page_content = str_replace("{{template_url}}", $login_template_url, $page_content);

        // Errors
        $page_content = str_replace("{{errors}}", $errors ? $errors : '', $page_content);

        // Form fields
        $page_content = str_replace("{{email}}", isset($_POST["email"]) ? $_POST["email"] : "", $page_content);

        // Login Template 1
        if ($settings["login_settings"]["template"] == "login1")
        {
            // Logo
            if (isset($settings["login_settings"]["login1"]["logo_image"]))
                $page_content = str_replace("{{logo}}", $settings["login_settings"]["login1"]["logo_image"]["url"], $page_content);
            else
                $page_content = str_replace("{{logo}}", $login_template_url . "images/logo.png", $page_content);

            // Button Text
            $page_content = str_replace("{{button_text}}", htmlspecialchars(stripslashes($settings["login_settings"]["login1"]["button_text"])), $page_content);

            // Forgot Password Text
            $page_content = str_replace("{{forgot_password_text}}", htmlspecialchars(stripslashes($settings["login_settings"]["login1"]["forgot_password_text"])), $page_content);

            // Css
            $css = '<style>';

            // Css - Body
            $css .= "body {";
            $css .= "background:" . $settings["login_settings"]["login1"]["bg_color"] . ";";
            $css .= "}";

            // Css - Bg
            if (isset($settings["login_settings"]["login1"]["bg_use_image"]) && $settings["login_settings"]["login1"]["bg_use_image"] != "" && isset($settings["login_settings"]["login1"]["bg_image"]))
            {
                $css .= ".bg {";
                $css .= "background-image:url(" . $settings["login_settings"]["login1"]["bg_image"]["url"] . ");";
                $css .= "}";
            }
            else if (!isset($settings["login_settings"]["login1"]["bg_use_image"]) || $settings["login_settings"]["login1"]["bg_use_image"] == "")
            {
                $css .= ".bg {";
                $css .= "background-image:none;";
                $css .= "}";
            }

            // Css - Box
            $css .= ".login {";
            $css .= "background:" . $settings["login_settings"]["login1"]["box_bg_color"] . ";";
            $css .= "box-shadow: 0px 5px 0px " . $settings["login_settings"]["login1"]["box_shadow_color"] . ";";
            $css .= "}";

            // Css - Button
            $css .= ".submit-form {";
            $css .= "color:" . $settings["login_settings"]["login1"]["button_text_color"] . ";";
            $css .= "background-color:" . $settings["login_settings"]["login1"]["button_bg_color"] . ";";
            $css .= "box-shadow: 0px 4px 0px " . $settings["login_settings"]["login1"]["button_shadow_color"] . ";";
            $css .= "}";
        }

        // Login Template 2
        else if ($settings["login_settings"]["template"] == "login2")
        {
            // Logo
            if (isset($settings["login_settings"]["login2"]["logo_image"]))
                $page_content = str_replace("{{logo}}", $settings["login_settings"]["login2"]["logo_image"]["url"], $page_content);
            else
                $page_content = str_replace("{{logo}}", $login_template_url . "images/logo.png", $page_content);

            // Title
            $page_content = str_replace("{{title}}", htmlspecialchars(stripslashes($settings["login_settings"]["login2"]["title"])), $page_content);

            // Button Text
            $page_content = str_replace("{{button_text}}", htmlspecialchars(stripslashes($settings["login_settings"]["login2"]["button_text"])), $page_content);

            // Forgot Password Text
            $page_content = str_replace("{{forgot_password_text}}", htmlspecialchars(stripslashes($settings["login_settings"]["login2"]["forgot_password_text"])), $page_content);

            // Css
            $css = '<style>';

            // Css - Body
            $css .= "body {";
            $css .= "background:" . $settings["login_settings"]["login2"]["bg_color"] . ";";
            $css .= "}";

            // Css - Title
            $css .= ".login-text {";
            $css .= "color:" . $settings["login_settings"]["login2"]["title_color"] . ";";
            $css .= "}";

            // Css - Bg
            if (isset($settings["login_settings"]["login2"]["bg_image"]))
            {
                $css .= ".bg {";
                $css .= "background-image:url(" . $settings["login_settings"]["login2"]["bg_image"]["url"] . ");";
                $css .= "}";
            }

            // Css - Box
            $css .= ".login {";
            $css .= "background:" . $settings["login_settings"]["login2"]["box_bg_color"] . ";";
            $css .= "}";

            // Css - Button
            $css .= ".submit-form {";
            $css .= "color:" . $settings["login_settings"]["login2"]["button_text_color"] . ";";
            $css .= "background-color:" . $settings["login_settings"]["login2"]["button_bg_color"] . ";";
            $css .= "}";
        }

        // Login Template 3
        if ($settings["login_settings"]["template"] == "login3")
        {
            // Logo
            if (isset($settings["login_settings"]["login3"]["logo_image"]))
                $page_content = str_replace("{{logo}}", $settings["login_settings"]["login3"]["logo_image"]["url"], $page_content);
            else
                $page_content = str_replace("{{logo}}", $login_template_url . "images/logo.png", $page_content);

            // Button Text
            $page_content = str_replace("{{button_text}}", htmlspecialchars(stripslashes($settings["login_settings"]["login3"]["button_text"])), $page_content);

            // Forgot Password Text
            $page_content = str_replace("{{forgot_password_text}}", htmlspecialchars(stripslashes($settings["login_settings"]["login3"]["forgot_password_text"])), $page_content);

            // Css
            $css = '<style>';

            // Css - Body
            $css .= "body {";
            $css .= "background:" . $settings["login_settings"]["login3"]["bg_color"] . ";";
            $css .= "}";

            // Css - Bg
            if (isset($settings["login_settings"]["login3"]["bg_use_image"]) && $settings["login_settings"]["login3"]["bg_use_image"] != "" && isset($settings["login_settings"]["login3"]["bg_image"]))
            {
                $css .= ".bg {";
                $css .= "background-image:url(" . $settings["login_settings"]["login3"]["bg_image"]["url"] . ");";
                $css .= "}";
            }
            else if (!isset($settings["login_settings"]["login3"]["bg_use_image"]) || $settings["login_settings"]["login3"]["bg_use_image"] == "")
            {
                $css .= ".bg {";
                $css .= "background-image:none;";
                $css .= "}";
            }

            // Css - Button
            $css .= ".submit-form {";
            $css .= "color:" . $settings["login_settings"]["login3"]["button_text_color"] . ";";
            $css .= "background-color:" . $settings["login_settings"]["login3"]["button_bg_color"] . ";";
            $css .= "}";
        }


        // Css - Views
        if (isset($_GET["reset"]) && !isset($_POST["igloo_login"]))
        {
            // Password correctly reset
            if ($password_reset)
            {
                $css .= '#login_form {display: none;}';
                // $css .= '#lost_password_form {display: none;}';
                $css .= '#success_message {display: block;}';
                $page_content = str_replace("{{success_message}}", "Your new password has been set", $page_content);
            }
            else
            {
                $css .= '#login_form {display: none;}';
                // $css .= '#lost_password_form {display: none;}';
                $css .= '#reset_form {display: block;}';
            }
        }
        else if ($view == "lost_password")
        {
            if ($email_sent)
            {
                $css .= '#login_form {display: none;}';
                // $css .= '#lost_password_form {display: none;}';
                $css .= '#success_message {display: block;}';
                $page_content = str_replace("{{success_message}}", "We've sent you an email with a link to reset your password", $page_content);
            }
            else
            {
                $css .= '#login_form {display: none;}';
                $css .= '#lost_password_form {display: block;}';
            }
        }

        $css .= '</style>';
        $page_content = str_replace("{{css}}", $css, $page_content);
        // $page_content = str_replace("{{background_color}}", isset($_POST["first_name"]) ? $_POST["first_name"] : "", $page_content);

        echo $page_content;
        die();
    }



    public function showRegistration($error = false, $template = false)
    {
        $settings = $this->getSettings();

        if ($template)
            $settings["signup_settings"]["template"] = $template;

        // echo "SHOW LOGIN<br />";
        $signup_template_path = $this->ROOT_PATH . "/templates/signup/" . $settings["signup_settings"]["template"] . "/";
        $signup_template_url = $this->PLUGIN_URL . "/templates/signup/" . $settings["signup_settings"]["template"] . "/";
        $page_content = file_get_contents($signup_template_path . "index.html");

        // Basic Replacements
        $page_content = str_replace("{{template_url}}", $signup_template_url, $page_content);

        // Form fields
        $page_content = str_replace("{{last_name}}", isset($_POST["last_name"]) ? $_POST["last_name"] : "", $page_content);
        $page_content = str_replace("{{email}}", isset($_POST["email"]) ? $_POST["email"] : "", $page_content);
        $page_content = str_replace("{{first_name}}", isset($_POST["first_name"]) ? $_POST["first_name"] : "", $page_content);
        $page_content = str_replace("{{last_name}}", isset($_POST["last_name"]) ? $_POST["last_name"] : "", $page_content);
        $page_content = str_replace("{{email}}", isset($_POST["email"]) ? $_POST["email"] : "", $page_content);

        // Errors
        if ($error)
        {
            switch ($error["code"]) {
                case 'REQUIRED':
                    $error_message = "All fields are required";
                    break;
                case 'EMAIL_NOT_VALID':
                    $error_message = "The email address is not valid";
                    break;
                case 'EMAIL_EXISTS':
                    $error_message = "The email address is already in use";
                    break;
                case 'PASSWORDS_LENGTH':
                    $error_message = "Please enter a password at least 6 characters in length";
                    break;
                case 'PASSWORDS_DO_NOT_MATCH':
                    $error_message = "The two passwords do not match";
                    break;
            }
            $page_content = str_replace("{{errors}}", $error_message, $page_content);
        }
        else
            $page_content = str_replace("{{errors}}", "", $page_content);

        // Signup Template 1
        if ($settings["signup_settings"]["template"] == "signup1")
        {
            // Logo
            if (isset($settings["signup_settings"]["signup1"]["logo_image"]))
                $page_content = str_replace("{{logo}}", $settings["signup_settings"]["signup1"]["logo_image"]["url"], $page_content);
            else
                $page_content = str_replace("{{logo}}", $signup_template_url . "images/logo.png", $page_content);

            // Button Text
            $page_content = str_replace("{{button_text}}", htmlspecialchars(stripslashes($settings["signup_settings"]["signup1"]["button_text"])), $page_content);

            // Forgot Password Text
            // $page_content = str_replace("{{forgot_password_text}}", htmlspecialchars(stripslashes($settings["signup_settings"]["signup1"]["forgot_password_text"])), $page_content);

            // Css
            $css = '<style>';

            // Css - Body
            $css .= "body {";
            $css .= "background:" . $settings["signup_settings"]["signup1"]["bg_color"] . ";";
            $css .= "}";

            // Css - Bg
            if (isset($settings["signup_settings"]["signup1"]["bg_use_image"]) && $settings["signup_settings"]["signup1"]["bg_use_image"] != "" && isset($settings["signup_settings"]["signup1"]["bg_image"]))
            {
                $css .= ".bg {";
                $css .= "background-image:url(" . $settings["signup_settings"]["signup1"]["bg_image"]["url"] . ");";
                $css .= "}";
            }
            else if (!isset($settings["signup_settings"]["signup1"]["bg_use_image"]) || $settings["signup_settings"]["signup1"]["bg_use_image"] == "")
            {
                $css .= ".bg {";
                $css .= "background-image:none;";
                $css .= "}";
            }

            // Css - Box
            $css .= ".login {";
            $css .= "background:" . $settings["signup_settings"]["signup1"]["box_bg_color"] . ";";
            $css .= "box-shadow: 0px 5px 0px " . $settings["signup_settings"]["signup1"]["box_shadow_color"] . ";";
            $css .= "}";

            // Css - Button
            $css .= ".submit-form {";
            $css .= "color:" . $settings["signup_settings"]["signup1"]["button_text_color"] . ";";
            $css .= "background-color:" . $settings["signup_settings"]["signup1"]["button_bg_color"] . ";";
            $css .= "box-shadow: 0px 4px 0px " . $settings["signup_settings"]["signup1"]["button_shadow_color"] . ";";
            $css .= "}";
        }

        // Signup Template 2
        else if ($settings["signup_settings"]["template"] == "signup2")
        {
            // Logo
            if (isset($settings["signup_settings"]["signup2"]["logo_image"]))
                $page_content = str_replace("{{logo}}", $settings["signup_settings"]["signup2"]["logo_image"]["url"], $page_content);
            else
                $page_content = str_replace("{{logo}}", $signup_template_url . "images/logo.png", $page_content);

            // Title
            $page_content = str_replace("{{title}}", htmlspecialchars(stripslashes($settings["signup_settings"]["signup2"]["title"])), $page_content);

            // Button Text
            $page_content = str_replace("{{button_text}}", htmlspecialchars(stripslashes($settings["signup_settings"]["signup2"]["button_text"])), $page_content);

            // Forgot Password Text
            // $page_content = str_replace("{{forgot_password_text}}", htmlspecialchars(stripslashes($settings["signup_settings"]["signup2"]["forgot_password_text"])), $page_content);

            // Css
            $css = '<style>';

            // Css - Body
            $css .= "body {";
            $css .= "background:" . $settings["signup_settings"]["signup2"]["bg_color"] . ";";
            $css .= "}";

            // Css - Title
            $css .= ".login-text {";
            $css .= "color:" . $settings["signup_settings"]["signup2"]["title_color"] . ";";
            $css .= "}";

            // Css - Bg
            if (isset($settings["signup_settings"]["signup2"]["bg_image"]))
            {
                $css .= ".bg {";
                $css .= "background-image:url(" . $settings["signup_settings"]["signup2"]["bg_image"]["url"] . ");";
                $css .= "}";
            }

            // Css - Box
            $css .= ".login {";
            $css .= "background:" . $settings["signup_settings"]["signup2"]["box_bg_color"] . ";";
            $css .= "}";

            // Css - Button
            $css .= ".submit-form {";
            $css .= "color:" . $settings["signup_settings"]["signup2"]["button_text_color"] . ";";
            $css .= "background-color:" . $settings["signup_settings"]["signup2"]["button_bg_color"] . ";";
            $css .= "}";
        }

        // Signup Template 3
        if ($settings["signup_settings"]["template"] == "signup3")
        {
            // Logo
            if (isset($settings["signup_settings"]["signup3"]["logo_image"]))
                $page_content = str_replace("{{logo}}", $settings["signup_settings"]["signup3"]["logo_image"]["url"], $page_content);
            else
                $page_content = str_replace("{{logo}}", $signup_template_url . "images/logo.png", $page_content);

            // Button Text
            $page_content = str_replace("{{button_text}}", htmlspecialchars(stripslashes($settings["signup_settings"]["signup3"]["button_text"])), $page_content);

            // Forgot Password Text
            // $page_content = str_replace("{{forgot_password_text}}", htmlspecialchars(stripslashes($settings["signup_settings"]["signup3"]["forgot_password_text"])), $page_content);

            // Css
            $css = '<style>';

            // Css - Body
            $css .= "body {";
            $css .= "background:" . $settings["signup_settings"]["signup3"]["bg_color"] . ";";
            $css .= "}";

            // Css - Bg
            if (isset($settings["signup_settings"]["signup3"]["bg_use_image"]) && $settings["signup_settings"]["signup3"]["bg_use_image"] != "" && isset($settings["signup_settings"]["signup3"]["bg_image"]))
            {
                $css .= ".bg {";
                $css .= "background-image:url(" . $settings["signup_settings"]["signup3"]["bg_image"]["url"] . ");";
                $css .= "}";
            }
            else if (!isset($settings["signup_settings"]["signup3"]["bg_use_image"]) || $settings["signup_settings"]["signup3"]["bg_use_image"] == "")
            {
                $css .= ".bg {";
                $css .= "background-image:none;";
                $css .= "}";
            }

            // Css - Button
            $css .= ".submit-form {";
            $css .= "color:" . $settings["signup_settings"]["signup3"]["button_text_color"] . ";";
            $css .= "background-color:" . $settings["signup_settings"]["signup3"]["button_bg_color"] . ";";
            $css .= "}";
        }

        $css .= '</style>';
        $page_content = str_replace("{{css}}", $css, $page_content);

        echo $page_content;
        die();
    }




    // Admin - OTO3 /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public function ajaxOTO3Passed()
    {
        $settings = $this->getSettings();
        $settings["user"] = array(
            "email" => $_POST["email"],
            "api_key" => $_POST["api_key"],
        );
        update_option(self::PLUGIN_NAME . '_settings', $settings);

        die(json_encode(array(
            'success' => true
        )));
    }



    // Admin - Real Login Page /////////////////////////////////////////////////////////////////////////////////////////////////////////


    public function updateLoginPage($settings, $login_page_id)
    {
        // Page Content
        $page_content = "This page has been created by iGloo Member plugin. Please do not edit or delete this page.";

        // if (isset($settings["login_page_id"]))
        //     wp_delete_post($settings["login_page_id"], true);

        // Create Page
        $login_page = array(
            'ID' => $login_page_id,
            'post_name' => wp_strip_all_tags($settings["login_page_url"]),
            'post_title' => wp_strip_all_tags($settings["login_page_url"]),
            'post_content' => $page_content,
            'post_status' => 'publish',
            // 'post_author' => 1,
            'post_type' => "page",
            'comment_status' => 'closed',
            'ping_status' => 'closed'
        );
        $login_page_id = wp_insert_post($login_page);

        // return array(
        //     "success" => true,
        //     "id" => $post_id
        // );

    }




    // Admin - Settings /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public function ajaxUpdateSettings()
    {
        $settings = $_POST["settings"];
        $settings_on_db = get_option(self::PLUGIN_NAME . '_settings');

        // Creating / Updating the real login page
        $res = $this->updateLoginPage($settings, $settings_on_db["login_page_id"]);
        // $settings["login_page_id"] = $res["id"];

        $settings["login_page_id"] = $settings_on_db["login_page_id"];

        update_option(self::PLUGIN_NAME . '_settings', $settings);

        die(json_encode(array(
            'success' => true
        )));
    }

    public function getSettings()
    {
        $settings = get_option(self::PLUGIN_NAME . '_settings');

        $ps = get_option('permalink_structure');
        $settings["permalinks"] = $ps;

        if (isset($settings["levels"]) && !empty($settings["levels"]))
        {
            $users_per_level = $this->user->getLevels();
            foreach ($settings["levels"] as $idx => $level) {
                $settings["levels"][$idx]["after_login_page"] = isset($settings["levels"][$idx]["after_login_page"]) ? intval($settings["levels"][$idx]["after_login_page"]) : "";
                $settings["levels"][$idx]["after_registration_page"] = isset($settings["levels"][$idx]["after_registration_page"]) ? intval($settings["levels"][$idx]["after_registration_page"]) : "";
                $settings["levels"][$idx]["num_users"] = isset($users_per_level[$level["id"]]) ? $users_per_level[$level["id"]] : 0;
            }
        }

        $settings["site_url"] = site_url();
        $settings["plugin_url"] = $this->PLUGIN_URL;
        $settings["stats"] = $this->user->getStats();

        // Defaults
        foreach ($this->defaults_settings as $key => $value) {
            if (!isset($settings[$key]))
                $settings[$key] = $value;
        }
        $settings["defaults"] = $this->defaults_settings;

        // Sender Email
        if ($settings["email_sender"] == "")
        {
            $settings["email_sender"] = get_option('admin_email');
            $settings["defaults"]["email_sender"] = get_option('admin_email');
        }

        return $settings;
    }

    public function ajaxLoadSettings()
    {
        die(json_encode(array(
            "settings" => $this->getSettings()
        )));
    }



    // Admin - Levels /////////////////////////////////////////////////////////////////////////////////////////////////////////


    public function ajaxCreateLevel()
    {
        if (!isset($_POST["params"]))
            return;

        $new_level = $_POST["params"];
        $settings = $this->getSettings();

        if (!isset($settings["levels"]))
            $settings["levels"] = array();

        $new_level["id"] = 0;
        foreach ($settings["levels"] as $key => $value) {
            if ($value["id"] > $new_level["id"])
                $new_level["id"] = $value["id"];
        }
        $new_level["id"]++;

        // $settings["levels"][] = $new_level;
        array_push($settings["levels"], $new_level);
        update_option(self::PLUGIN_NAME . '_settings', $settings);

        die(json_encode(array(
            'success' => true
        )));
    }

    public function ajaxUpdateLevel()
    {
        $params = isset($_POST["params"]) ? $_POST["params"] : null;
        $result = $this->user->update($params);

        if (isset($result["error"]))
            die(json_encode($result));

        die(json_encode(array(
            "success" => true
        )));
    }




    // Admin - Users /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public function ajaxCreateUser()
    {
        $params = isset($_POST["params"]) ? $_POST["params"] : null;
        $result = $this->user->create($params, $this->getSettings());

        if (isset($result["error"]))
            die(json_encode($result));

        die(json_encode(array(
            "id" => $result
        )));
    }

    public function ajaxUpdateUser()
    {
        $params = isset($_POST["params"]) ? $_POST["params"] : null;
        $result = $this->user->update($params);

        if (isset($result["error"]))
            die(json_encode($result));

        die(json_encode(array(
            "success" => true
        )));
    }

    public function ajaxDeleteUser()
    {
        if (!isset($_POST["params"]) || !isset($_POST["params"]["id"]))
            return;

        $result = $this->user->delete($_POST["params"]["id"]);

        if (isset($result["error"]))
            die(json_encode($result));

        die(json_encode(array(
            "success" => true
        )));
    }

    public function ajaxGetUsers()
    {
        $params = isset($_POST["params"]) ? $_POST["params"] : null;
        $result = $this->user->get($params);

        if (isset($result["error"]))
            die(json_encode($result));

        die(json_encode($result));
    }


    // Admin - Pages /////////////////////////////////////////////////////////////////////////////////////////////////////////

    public function ajaxGetPages()
    {
        $args = array(
        	'sort_order' => 'asc',
        	'sort_column' => 'post_title',
        	'hierarchical' => 1,
        	'exclude' => '',
        	'include' => '',
        	'meta_key' => '',
        	'meta_value' => '',
        	'authors' => '',
        	'child_of' => 0,
        	'parent' => -1,
        	'exclude_tree' => '',
        	'number' => '',
        	'offset' => 0,
        	'post_type' => 'page',
        	'post_status' => 'publish,inherit,pending,private,future,draft',
        );
        $result = get_pages($args);

        $pages = array();
        foreach ($result as $key => $page)
        {
            $pages[$key]["ID"] = $page->ID;
            $pages[$key]["post_title"] = $page->post_title;
            $pages[$key]["post_status"] = $page->post_status;
            $pages[$key]["guid"] = $page->guid;
            $pages[$key]["permalink"] = get_permalink($page->ID);
            $pages[$key]["igloo"] = (substr($page->post_content, 0, 8) == '{{IGLOO=');
            $pages[$key]["levels"] = get_post_meta($page->ID, "igloo_levels", true);
            $pages[$key]["redirect_if_not_logged"] = intval(get_post_meta($page->ID, "igloo_redirect_if_not_logged", true));
            $pages[$key]["days"] = intval(get_post_meta($page->ID, "igloo_days", true));
        }

        die(json_encode($pages));
    }


    public function ajaxSavePages()
    {
        if (!empty($_POST["params"]))
        {
            foreach ($_POST["params"] as $page)
            {
                if (isset($page["levels"]) && !is_null($page["levels"]))
                    update_post_meta($page["ID"], "igloo_levels", $page["levels"]);
                else
                    delete_post_meta($page["ID"], "igloo_levels");

                if (isset($page["redirect_if_not_logged"]) && !is_null($page["redirect_if_not_logged"]) && $page["redirect_if_not_logged"] != "" && $page["redirect_if_not_logged"] != "0")
                    update_post_meta($page["ID"], "igloo_redirect_if_not_logged", $page["redirect_if_not_logged"]);
                else
                    delete_post_meta($page["ID"], "igloo_redirect_if_not_logged");

                if (isset($page["days"]) && !is_null($page["days"]) && $page["days"] != "" && $page["days"] != "0")
                    update_post_meta($page["ID"], "igloo_days", $page["days"]);
                else
                    delete_post_meta($page["ID"], "igloo_days");
            }
        }


        die(json_encode(array(
            "success" => true
        )));
    }



}


$iGlooMembership = new iGlooMembership();

